#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>       //Download: https://www.electronoobs.com/eng_arduino_Adafruit_GFX.php
#include <Adafruit_SSD1306.h>   //Downlaod: https://www.electronoobs.com/eng_arduino_Adafruit_SSD1306.php
Adafruit_SSD1306 display(4);    //Create screen variable

#include <Wire.h>
#include <Adafruit_ADS1015.h>   //Download: https://electronoobs.com/eng_arduino_Adafruit_ADS1015.php
 
Adafruit_ADS1115 ads(0x48);
Adafruit_ADS1115 ads2(0x49);
const float multiplier = 0.1875F;   //From datasheet

//Define all the Input/output pins of the board
int D2 = 2;     //MUX 1
int D3 = 3;     //MUX 2
int D4 = 4;     //Resistance 20K
int D5 = 5;     //Resistance 470K
int D6 = 6;     //Inductance pulse
int D7 = 7;     //Voltage divider R
int D8 = 8;     //Resistance 2K
int D9 = 9;     //Inductance out
int D10 = 10;   //Push button
int D11 = 11;   //Capacitance 10K
int D12 = 12;   //Voltage divider L
int D13 = 13;   //Capacitance 220K
int a0 = A0;    //Capacitance Read
int a1 = A1;    //Resistance diode 
int a2 = A2;    //Capacitance RC
int a3 = A3;    //MUX 0
int a6 = A6;    
int a7 = A7;    


//Inductance mode variables
double pulse, frequency, Induct_cap, inductance;


void setup() {
  //Define all pins as inputs but not the pins that we will use
  //pinMode(a0, INPUT);
  pinMode(a1, INPUT);
  pinMode(a2, INPUT);
  pinMode(a3, INPUT);
  pinMode(a6, INPUT);
  pinMode(a7, INPUT);  
  //pinMode(D2, INPUT);
  //pinMode(D3, INPUT);
  pinMode(D4, INPUT);
  pinMode(D5, INPUT);
  //pinMode(D6, INPUT);
  pinMode(D7, INPUT);
  pinMode(D8, INPUT);
  pinMode(D9, INPUT);
  pinMode(D10, INPUT);
  pinMode(D11, INPUT);
  pinMode(D12, INPUT);
  pinMode(D13, INPUT);

  ads.begin();  //Start i2c communication with the first ADS1115
  ads2.begin();  //Start i2c communication with the second ADS1115
  
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);  //Start i2c communication
  //display.setRotation(2);                     //Rotate screen 180 degree
  display.clearDisplay();                     //Clear the display data
  display.display();                          //Send data to the display
  delay(10);

}

void loop() {
  display.clearDisplay();  
  display.setTextSize(2);
  display.setTextColor(WHITE);    
  display.setCursor(4,0);
  display.print("INDUCTANCE");  
  display.display();
  
  //MUX setup
  pinMode(a3, OUTPUT);  //S0 of mux
  pinMode(D2, OUTPUT);  //S1 of mux
  pinMode(D3, OUTPUT);  //S2 of mux
  //We set "011" so we activate MUX4 for Resistance mode (L)
  digitalWrite(a3, HIGH);   //S0 to 1
  digitalWrite(D2, HIGH);   //S1 to 1
  digitalWrite(D3, LOW);    //S2 to 0

  pinMode(A0, OUTPUT);  
  digitalWrite(A0, LOW);
  
  pinMode(D6, OUTPUT);  
  digitalWrite(D6, HIGH);
  delay(4);//give some time to charge inductor.
  digitalWrite(D6,LOW);
  delayMicroseconds(100);               //Make sure resonation is measured
  
  pulse = pulseIn(D9,HIGH,5000);        //returns 0 if timeout
  if(pulse > 0.1)                       //if a timeout did not occur and it took a reading:
  {      
    //#error insert your used capacitance value here. Currently using 2uF. Delete this line after that
    Induct_cap = 2.E-6;                 // - insert value here (in my cse 2x1uF)
        
    frequency = 1.E6/(2*pulse);
    inductance = 1./(Induct_cap*frequency*frequency*4.*3.14159*3.14159);  //one of my profs told me just do squares like this
    inductance *= 1E6;                                                    //note that this is the same as saying inductance = inductance*1E6
    
    display.clearDisplay();  
    display.setTextSize(2);
    display.setTextColor(WHITE);    
    display.setCursor(4,0);
    display.print("INDUCTANCE");
    
    display.setTextSize(2);
    display.setTextColor(WHITE);    
    display.setCursor(0,18);
    display.print(inductance,2);
    display.println(" uH");
    display.display();
    delay(100);      
  }

}//End of void lop
